
void new_file(GtkWidget *widget, gpointer *data)
{
   add_new_file("Untitled", FALSE);
   display_message("New file created.", FLASH);
}

void open_file(GtkWidget *widget, gpointer *data)
{
   file_selector = gtk_file_selection_new ("Open File");
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(file_selector),"~/.gCatalog/");
   gtk_signal_connect(GTK_OBJECT(file_selector), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION (file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(file_ok_sel),  file_selector);
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_widget_show(file_selector);
}

void file_ok_sel(GtkWidget *widget, GtkFileSelection *fs)
{
   gchar *string;   
   string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
   add_new_file(string, TRUE);
   display_message("File opened.", FLASH);
}

void close_file(GtkWidget *widget, gpointer *data)
{
   remove(cur_file->tempfile);
   remove(cur_file->undofile);
   total_files--;
   int x = cur_page;
   gtk_notebook_remove_page(GTK_NOTEBOOK(mdi_book), cur_page);
   cur_page = gtk_notebook_get_current_page(GTK_NOTEBOOK(mdi_book));
   delete file_list[x];
   if(total_files == 0)
   {
      cur_file = NULL;
      adjust_sensitivity();
      display_message("File closed.", FLASH);
      return;
   }
   while(x < total_files)
   {
      file_list[x] = file_list[x + 1];
      x++;
   }
   gtk_notebook_set_page(GTK_NOTEBOOK(mdi_book), cur_page);   
   adjust_sensitivity();
   display_message("File closed.", FLASH);
   return;
}

void save_file(GtkWidget *widget, gpointer *data)
{
   if((strcmp(cur_file->filename, "Untitled")) == 0)
   {
      save_file_as(widget, data);
      return;
   }
   else
   {
      copy_file(cur_file->tempfile, cur_file->filename);
      flush_file(tempfile);
      cur_file->saved = TRUE;
      adjust_sensitivity();
      display_message("File saved.", FLASH);
      return;
   }
}


void save_file_as(GtkWidget *widget, gpointer *data)
{
   file_selector = gtk_file_selection_new("Save File As");
   gtk_signal_connect(GTK_OBJECT(file_selector), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(save_as),  file_selector);
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_widget_show(file_selector);
}


void save_as(GtkWidget *widget, GtkFileSelection *fs)
{
   gchar *string;
   string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
   copy_file(cur_file->tempfile, string);
   flush_file(tempfile);
   strcpy(cur_file->filename, string);
   gtk_notebook_set_tab_label_text(GTK_NOTEBOOK(mdi_book), GTK_WIDGET(cur_file->notebook_box), string);
   set_window_title();
   cur_file->saved = TRUE;
   adjust_sensitivity();
   display_message("File saved.", FLASH);
}


void copy_file(gchar *source, gchar *dest)
{
   char input[LINE_LENGTH];
   ifstream Input;
   Input.open(source);
   ofstream Output;
   Output.open(dest);
   while(Input.getline(input, LINE_LENGTH) != NULL)
   {
      Output << input << endl;
   }   
   Input.close();
   Output.close();
}      
